# How to Contribute to `Starmatrix`

Every contributor is welcome, regardless of their programming experience, if any.
There are several ways you can contribute to this project, here is a not exahustive list:

## Report an issue

The prefered way to report any bug is [opening an issue in the project's Github repo](https://github.com/xuanxu/starmatrix/issues/new).

For more informal communication, you can contact [@xuanxu via twitter](https://twitter.com/xuanxu)

## Resolve an issue

Pull requests are welcome. If you want to contribute code to solve an open issue:

* Add a comment to tell everyone you are working on the issue.
* If an issue has someone assigned it means that person is already working on it.
* Fork the project.
* Create a topic branch based on main.
* Commit there your code to solve the issue.
* Make sure all test are passing (and add specs to test any new feature if needed).
* Follow the code styles and practices already in place.
* Open a *pull request* to the main repository mentioning the issue you are addressing.

## Cleaning up

In the rush of time sometimes things get messy, you can help us cleaning things up:

* implementing pending specs
* increasing code coverage
* improving code quality
* updating dependencies
* making code consistent

## Other ways of contributing without coding

* If you think there's a feature missing, or find a bug, create an issue (make sure it has not already been reported).
* You can also help promoting the project talking about it in your work groups or social networks.
* Improving the docs is always needed, documenting use cases or writing tutorials are great additions.

## How to report an issue

* Try to use a descriptive and to-the-point title
* Is a good idea to include some of these sections:
  * Steps to reproduce the bug
  * Expected behaviour/response
  * Actual response
* Sometimes it is also helpful if you mention your operating system or shell.

## Code of Conduct

Obviously there is very little chance of having fun or creating anything interesting in an environment where people do not feel safe. That's why `starmatrix` has a [Code of Conduct](CODE_OF_CONDUCT.md) every contributor must comply. Please read it if you plan to be part of the `starmatrix` community.


Thanks! :heart: :heart: :heart:
